
#ifndef PROBLEM_IO_H
#define PROBLEM_IO_H

#include "index_type.h"
using namespace HSPS;

void read_basic_problem(index_type& p, index_set_vec& o);
void make_inclusion_matrix(index_type np,
			   const index_set_vec& o,
			   bool_matrix& m);
void read_durations(index_type np, index_vec& d);
void read_schedule(index_type p, index_vec& s);
void read_weighted_problem(index_type& p,
			   index_set_vec& o,
			   index_matrix& c);

void compute_open_schedule(const index_set_vec& o,
			   const index_vec& s,
			   index_vec& f,
			   index_vec& l,
			   index_vec& n);
void compute_open_profile(const index_vec& f,
			  const index_vec& l,
			  index_type nn,
			  index_vec& n);

void write_open_schedule(std::ostream& to,
			 const index_set_vec& o,
			 const index_vec& s,
			 index_matrix* c);

void write_sp_plan(std::ostream& to,
		   const index_set_vec& o,
		   const index_vec& s,
		   index_type m,
		   bool inv_count);

void write_seq_plan(std::ostream& to,
		    const index_set_vec& o,
		    const index_vec& s,
		    index_type m);

#endif
