
#ifndef SOFT_SOLVER
#define SOFT_SOLVER

#include "basic_solver.h"

extern bool bb_print_plan;
extern bool bb_verbose;

index_type exp_loss(index_type n_rem, index_type o_rem);

void bb_exp_loss(const index_set_vec& o,
		 const index_vec& s,
		 index_type m,
		 const index_vec& invs,
		 index_vec& rem,
		 index_vec& f,
		 index_vec& l,
		 index_vec& n,
		 index_type acc,
		 index_type& U,
		 index_set_vec& o_min);

index_type min_exp_loss(const index_set_vec& o,
			const index_vec& s,
			index_type m,
			index_type U,
			index_set_vec& o_min);

extern count_type bb_lin_calls;
extern count_type bb_calls_limit;

void bb_lin_loss(index_set_vec& o,
		 const index_vec& s,
		 index_type m,
		 const index_vec& invs,
		 index_vec& f,
		 index_vec& l,
		 index_vec& n,
		 index_type acc,
		 index_type& U,
		 index_set_vec& o_min);

index_type min_lin_loss(const index_set_vec& o,
			const index_vec& s,
			index_type m,
			index_type U,
			index_set_vec& o_min);

#endif
